/**
 */
package org.example.democatalog.util;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notifier;

import org.eclipse.emf.common.notify.impl.AdapterFactoryImpl;

import org.eclipse.emf.ecore.EObject;

import org.example.democatalog.*;

/**
 * <!-- begin-user-doc -->
 * The <b>Adapter Factory</b> for the model.
 * It provides an adapter <code>createXXX</code> method for each class of the model.
 * <!-- end-user-doc -->
 * @see org.example.democatalog.DemocatalogPackage
 * @generated
 */
public class DemocatalogAdapterFactory extends AdapterFactoryImpl {
	/**
	 * The cached model package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static DemocatalogPackage modelPackage;

	/**
	 * Creates an instance of the adapter factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public DemocatalogAdapterFactory() {
		if (modelPackage == null) {
			modelPackage = DemocatalogPackage.eINSTANCE;
		}
	}

	/**
	 * Returns whether this factory is applicable for the type of the object.
	 * <!-- begin-user-doc -->
	 * This implementation returns <code>true</code> if the object is either the model's package or is an instance object of the model.
	 * <!-- end-user-doc -->
	 * @return whether this factory is applicable for the type of the object.
	 * @generated
	 */
	@Override
	public boolean isFactoryForType(Object object) {
		if (object == modelPackage) {
			return true;
		}
		if (object instanceof EObject) {
			return ((EObject) object).eClass().getEPackage() == modelPackage;
		}
		return false;
	}

	/**
	 * The switch that delegates to the <code>createXXX</code> methods.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected DemocatalogSwitch<Adapter> modelSwitch = new DemocatalogSwitch<Adapter>() {
		@Override
		public Adapter caseEnergyComponentCatalog(EnergyComponentCatalog object) {
			return createEnergyComponentCatalogAdapter();
		}

		@Override
		public Adapter caseBoiler(Boiler object) {
			return createBoilerAdapter();
		}

		@Override
		public Adapter caseCombinedHeatPower(CombinedHeatPower object) {
			return createCombinedHeatPowerAdapter();
		}

		@Override
		public Adapter caseSolarPanel(SolarPanel object) {
			return createSolarPanelAdapter();
		}

		@Override
		public Adapter caseInverter(Inverter object) {
			return createInverterAdapter();
		}

		@Override
		public Adapter caseManufacturer(Manufacturer object) {
			return createManufacturerAdapter();
		}

		@Override
		public Adapter caseChemicalDevice(ChemicalDevice object) {
			return createChemicalDeviceAdapter();
		}

		@Override
		public Adapter caseEnergyComponent(EnergyComponent object) {
			return createEnergyComponentAdapter();
		}

		@Override
		public Adapter caseElectricalDevice(ElectricalDevice object) {
			return createElectricalDeviceAdapter();
		}

		@Override
		public Adapter defaultCase(EObject object) {
			return createEObjectAdapter();
		}
	};

	/**
	 * Creates an adapter for the <code>target</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param target the object to adapt.
	 * @return the adapter for the <code>target</code>.
	 * @generated
	 */
	@Override
	public Adapter createAdapter(Notifier target) {
		return modelSwitch.doSwitch((EObject) target);
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.example.democatalog.EnergyComponentCatalog <em>Energy Component Catalog</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.example.democatalog.EnergyComponentCatalog
	 * @generated
	 */
	public Adapter createEnergyComponentCatalogAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.example.democatalog.Boiler <em>Boiler</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.example.democatalog.Boiler
	 * @generated
	 */
	public Adapter createBoilerAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.example.democatalog.CombinedHeatPower <em>Combined Heat Power</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.example.democatalog.CombinedHeatPower
	 * @generated
	 */
	public Adapter createCombinedHeatPowerAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.example.democatalog.SolarPanel <em>Solar Panel</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.example.democatalog.SolarPanel
	 * @generated
	 */
	public Adapter createSolarPanelAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.example.democatalog.Inverter <em>Inverter</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.example.democatalog.Inverter
	 * @generated
	 */
	public Adapter createInverterAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.example.democatalog.Manufacturer <em>Manufacturer</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.example.democatalog.Manufacturer
	 * @generated
	 */
	public Adapter createManufacturerAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.example.democatalog.ChemicalDevice <em>Chemical Device</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.example.democatalog.ChemicalDevice
	 * @generated
	 */
	public Adapter createChemicalDeviceAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.example.democatalog.EnergyComponent <em>Energy Component</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.example.democatalog.EnergyComponent
	 * @generated
	 */
	public Adapter createEnergyComponentAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.example.democatalog.ElectricalDevice <em>Electrical Device</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.example.democatalog.ElectricalDevice
	 * @generated
	 */
	public Adapter createElectricalDeviceAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for the default case.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @generated
	 */
	public Adapter createEObjectAdapter() {
		return null;
	}

} //DemocatalogAdapterFactory
