/**
 */
package org.example.democatalog.util;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.util.Switch;

import org.example.democatalog.*;

/**
 * <!-- begin-user-doc -->
 * The <b>Switch</b> for the model's inheritance hierarchy.
 * It supports the call {@link #doSwitch(EObject) doSwitch(object)}
 * to invoke the <code>caseXXX</code> method for each class of the model,
 * starting with the actual class of the object
 * and proceeding up the inheritance hierarchy
 * until a non-null result is returned,
 * which is the result of the switch.
 * <!-- end-user-doc -->
 * @see org.example.democatalog.DemocatalogPackage
 * @generated
 */
public class DemocatalogSwitch<T> extends Switch<T> {
	/**
	 * The cached model package
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static DemocatalogPackage modelPackage;

	/**
	 * Creates an instance of the switch.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public DemocatalogSwitch() {
		if (modelPackage == null) {
			modelPackage = DemocatalogPackage.eINSTANCE;
		}
	}

	/**
	 * Checks whether this is a switch for the given package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param ePackage the package in question.
	 * @return whether this is a switch for the given package.
	 * @generated
	 */
	@Override
	protected boolean isSwitchFor(EPackage ePackage) {
		return ePackage == modelPackage;
	}

	/**
	 * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the first non-null result returned by a <code>caseXXX</code> call.
	 * @generated
	 */
	@Override
	protected T doSwitch(int classifierID, EObject theEObject) {
		switch (classifierID) {
		case DemocatalogPackage.ENERGY_COMPONENT_CATALOG: {
			EnergyComponentCatalog energyComponentCatalog = (EnergyComponentCatalog) theEObject;
			T result = caseEnergyComponentCatalog(energyComponentCatalog);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case DemocatalogPackage.BOILER: {
			Boiler boiler = (Boiler) theEObject;
			T result = caseBoiler(boiler);
			if (result == null)
				result = caseChemicalDevice(boiler);
			if (result == null)
				result = caseEnergyComponent(boiler);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case DemocatalogPackage.COMBINED_HEAT_POWER: {
			CombinedHeatPower combinedHeatPower = (CombinedHeatPower) theEObject;
			T result = caseCombinedHeatPower(combinedHeatPower);
			if (result == null)
				result = caseChemicalDevice(combinedHeatPower);
			if (result == null)
				result = caseEnergyComponent(combinedHeatPower);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case DemocatalogPackage.SOLAR_PANEL: {
			SolarPanel solarPanel = (SolarPanel) theEObject;
			T result = caseSolarPanel(solarPanel);
			if (result == null)
				result = caseElectricalDevice(solarPanel);
			if (result == null)
				result = caseEnergyComponent(solarPanel);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case DemocatalogPackage.INVERTER: {
			Inverter inverter = (Inverter) theEObject;
			T result = caseInverter(inverter);
			if (result == null)
				result = caseElectricalDevice(inverter);
			if (result == null)
				result = caseEnergyComponent(inverter);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case DemocatalogPackage.MANUFACTURER: {
			Manufacturer manufacturer = (Manufacturer) theEObject;
			T result = caseManufacturer(manufacturer);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case DemocatalogPackage.CHEMICAL_DEVICE: {
			ChemicalDevice chemicalDevice = (ChemicalDevice) theEObject;
			T result = caseChemicalDevice(chemicalDevice);
			if (result == null)
				result = caseEnergyComponent(chemicalDevice);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case DemocatalogPackage.ENERGY_COMPONENT: {
			EnergyComponent energyComponent = (EnergyComponent) theEObject;
			T result = caseEnergyComponent(energyComponent);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case DemocatalogPackage.ELECTRICAL_DEVICE: {
			ElectricalDevice electricalDevice = (ElectricalDevice) theEObject;
			T result = caseElectricalDevice(electricalDevice);
			if (result == null)
				result = caseEnergyComponent(electricalDevice);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		default:
			return defaultCase(theEObject);
		}
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Energy Component Catalog</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Energy Component Catalog</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseEnergyComponentCatalog(EnergyComponentCatalog object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Boiler</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Boiler</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseBoiler(Boiler object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Combined Heat Power</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Combined Heat Power</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseCombinedHeatPower(CombinedHeatPower object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Solar Panel</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Solar Panel</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseSolarPanel(SolarPanel object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Inverter</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Inverter</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseInverter(Inverter object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Manufacturer</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Manufacturer</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseManufacturer(Manufacturer object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Chemical Device</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Chemical Device</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseChemicalDevice(ChemicalDevice object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Energy Component</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Energy Component</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseEnergyComponent(EnergyComponent object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Electrical Device</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Electrical Device</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseElectricalDevice(ElectricalDevice object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>EObject</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch, but this is the last case anyway.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>EObject</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject)
	 * @generated
	 */
	@Override
	public T defaultCase(EObject object) {
		return null;
	}

} //DemocatalogSwitch
